Index: NEMO/branches/2021/dev_r14122_HPC-08_Mueller_OSMOSIS_streamlining/doc/latex/global/info_page.tex
===================================================================
--- NEMO/branches/2021/dev_r14122_HPC-08_Mueller_OSMOSIS_streamlining/doc/latex/global/info_page.tex	(revision 14529)
+++ NEMO/branches/2021/dev_r14122_HPC-08_Mueller_OSMOSIS_streamlining/doc/latex/global/info_page.tex	(revision 14822)
@@ -1,12 +1,13 @@
+%% =================================================================================================
+%% Back cover
+%% =================================================================================================
 
-\thispagestyle{plain}
+%% Disclaimer
+%% =================================================================================================
 
-%% ================================================================
-%% Disclaimer
-%% ================================================================
 \subsubsection*{Disclaimer}
 
 Like all components of the modelling framework,
-the \engine\ core engine is developed under the \href{http://www.cecill.info}{CECILL license},
+the \eng\ core engine is developed under the \href{http://www.cecill.info}{CECILL license},
 which is a French adaptation of the GNU GPL (\textbf{G}eneral \textbf{P}ublic \textbf{L}icense).
 Anyone may use it freely for research purposes, and is encouraged to
@@ -20,32 +21,32 @@
 The authors assume no responsibility for problems, errors, or incorrect usage of \NEMO.
 
-%% ================================================================
 %% External resources
-%% ================================================================
+%% =================================================================================================
+
 \subsubsection*{Other resources}
 \label{resources}
 
 Additional information can be found on:
+
 \begin{itemize}
-\item \faWordpress\ the \href{http://www.nemo-ocean.eu}{website} of the project detailing several
-  associated applications and an exhaustive users bibliography
-\item \faCodeFork\ the \href{http://forge.ipsl.jussieu.fr/nemo}{development platform} of
-  the model with the code repository for the shared reference and some main resources
-  (wiki, ticket system, forums, \ldots) \\
-  \faGithub\ the \href{http://github.com/NEMO-ocean/NEMO-examples}
-  {repository of the demonstration cases} for research or training
-\item \faCloudDownload\ the \href{http://zenodo.org/communities/nemo-ocean}{online archive}
-  delivering the publications issued by the consortium (manuals, reports, datasets, \ldots)
-\item \faEnvelope\ two mailing lists:
-  the \href{http://listes.ipsl.fr/sympa/info/nemo-newsletter}{newsletter} for
-  top-down communications from the project
-  (announcements, calls, job opportunities, \ldots)
-  and the \href{http://listes.ipsl.fr/sympa/info/nemo-forge}{forge updates}
-  (commits, tickets and forums)
+   \item \faWordpress\ the \href{http://www.nemo-ocean.eu}{website} of the project detailing
+      several associated applications and an exhaustive users bibliography
+   \item \faCodeFork\ the \href{http://forge.ipsl.jussieu.fr/nemo}{development platform} of
+      the model with the code repository for the shared reference and some main resources
+      (wiki, ticket system, forums, \ldots) \\
+      \faGithub\ the \href{http://github.com/NEMO-ocean/NEMO-examples}
+      {repository of the demonstration cases} for research or training
+   \item \faCloudDownload\ the \href{http://zenodo.org/communities/nemo-ocean}{online archive}
+      delivering the publications issued by the consortium (manuals, reports, datasets, \ldots)
+   \item \faEnvelope\ two mailing lists:
+      the \href{http://listes.ipsl.fr/sympa/info/nemo-newsletter}{newsletter} for
+      top-down communications from the project (announcements, calls, job opportunities, \ldots)
+      and the \href{http://listes.ipsl.fr/sympa/info/nemo-forge}{forge updates}
+      (commits, tickets and forums)
 \end{itemize}
 
-%% ================================================================
 %% Citation
-%% ================================================================
+%% =================================================================================================
+
 \subsubsection*{Citation}
 
@@ -55,22 +56,24 @@
 
 \begin{sloppypar}
-  ``{\bfseries \heading}\ifdef{\subheading}{ -- \subheading}{}'',
-  {\em Scientific Notes of Climate Modelling Center}, \textbf{\ipslnum} --- ISSN 1288-1619,
-  Institut Pierre-Simon Laplace (IPSL),
-  \href{https://doi.org/10.5281/zenodo.\zid}{doi:10.5281/zenodo.\zid}
+   ``{\bfseries \hdg}\ifdef{\shdg}{ -- \shdg}{}'',
+   {\em Scientific Notes of Climate Modelling Center}, \textbf{\ipsl} --- ISSN 1288-1619,
+   Institut Pierre-Simon Laplace (IPSL),
+   \href{https://doi.org/10.5281/zenodo.\zid}{doi:10.5281/zenodo.\zid}
 \end{sloppypar}
 
 \begin{figure}[b]
-  \begin{minipage}[c]{0.7\textwidth}
-    \small
-    \ttfamily{
-      Scientific Notes of Climate Modelling Center \\
-      ISSN 1288-1619                               \\
-      Institut Pierre-Simon Laplace (IPSL)
-    }
-  \end{minipage}
-  \hfill
-  \begin{minipage}[c]{0.25\textwidth}
-    \href{http://www.cmc.ipsl.fr}{\includegraphics[width=\textwidth]{logos/IPSL_master}}
-  \end{minipage}
+
+   \begin{minipage}[c]{0.7\textwidth}
+      \small
+      \ttfamily{
+         Scientific Notes of Climate Modelling Center \\
+         ISSN 1288-1619                               \\
+         Institut Pierre-Simon Laplace (IPSL)
+      }
+   \end{minipage}
+   \hfill %% Don't insert void line between `minipage` envs
+   \begin{minipage}[c]{0.25\textwidth}
+      \href{http://www.cmc.ipsl.fr}{\includegraphics[width=\textwidth]{IPSL_master}}
+   \end{minipage}
+
 \end{figure}