Index: /utils/CI/sette_ticket2673/all_functions.sh
===================================================================
--- /utils/CI/sette_ticket2673/all_functions.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/all_functions.sh	(revision 14870)
@@ -379,6 +379,8 @@
     [ -f ${EXE_DIR}/run.stat ] && cp ${EXE_DIR}/*run.stat ${NEMO_VALIDATION_DIR}/.
     [ -f ${EXE_DIR}/output.namelist.dyn ] && cp ${EXE_DIR}/*output.nam* ${NEMO_VALIDATION_DIR}/.
+    [ -f ${EXE_DIR}/namelist_cfg ] && cp ${EXE_DIR}/*nam*_cfg ${NEMO_VALIDATION_DIR}/.
     [ -f ${EXE_DIR}/tracer.stat ] && cp ${EXE_DIR}/*tracer.stat ${NEMO_VALIDATION_DIR}/.
     [ -f ${EXE_DIR}/timing.output ] && cp ${EXE_DIR}/*timing.output ${NEMO_VALIDATION_DIR}/.
+    [ -f ${EXE_DIR}/sette_config ] && cp ${EXE_DIR}/sette_config ${NEMO_VALIDATION_DIR}/.
 
     if [ -n "$(ls ${NEMO_VALIDATION_DIR}/*run*)" ] ; then
Index: /utils/CI/sette_ticket2673/prepare_exe_dir.sh
===================================================================
--- /utils/CI/sette_ticket2673/prepare_exe_dir.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/prepare_exe_dir.sh	(revision 14870)
@@ -75,4 +75,24 @@
 #cat ${SETTE_DIR}/iodef_sette.xml | sed -e"s;DEF_SHARED;${CONFIG_DIR0}/SHARED;" > ${EXE_DIR}/iodef.xml
 cd ${EXE_DIR}
+#
+# Add summary of the sette.sh set-up used and the current list of keys added or deleted
+COMP_KEYS="`cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | sed -e 's/.*fppkeys *//'`"
+echo "Summary of sette environment"                                > ./sette_config
+echo "----------------------------"                               >> ./sette_config
+echo "requested by the command          : "$cmd $cmdargs          >> ./sette_config
+printf "%-33s : %s\n" USING_TIMING $USING_TIMING                  >> ./sette_config
+printf "%-33s : %s\n" USING_ICEBERGS $USING_ICEBERGS              >> ./sette_config
+printf "%-33s : %s\n" USING_EXTRA_HALO $USING_EXTRA_HALO          >> ./sette_config
+printf "%-33s : %s\n" USING_TILING $USING_TILING                  >> ./sette_config
+printf "%-33s : %s\n" USING_COLLECTIVES $USING_COLLECTIVES        >> ./sette_config
+printf "%-33s : %s\n" USING_NOSIGNED0 $USING_NOSIGNED0            >> ./sette_config
+printf "%-33s : %s\n" USING_QCO $USING_QCO                        >> ./sette_config
+printf "%-33s : %s\n" USING_LOOP_FUSION $USING_LOOP_FUSION        >> ./sette_config
+printf "%-33s : %s\n" USING_XIOS $USING_XIOS                      >> ./sette_config
+printf "%-33s : %s\n" USING_MPMD $USING_MPMD                      >> ./sette_config
+printf "%-33s : %s\n" USING_RK3 $USING_RK3                        >> ./sette_config
+printf "%-33s : %s\n" "Common compile keys added" "$ADD_KEYS"     >> ./sette_config
+printf "%-33s : %s\n" "Common compile keys deleted" "$DEL_KEYS"   >> ./sette_config
+printf "%-33s : %s\n" "Compile keys actually used" "${COMP_KEYS}" >> ./sette_config
 
 # Remove previously generated output files used for test evaluation
Index: /utils/CI/sette_ticket2673/sette.sh
===================================================================
--- /utils/CI/sette_ticket2673/sette.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/sette.sh	(revision 14870)
@@ -1,5 +1,5 @@
 #!/bin/sh
 # initialise user dependent variable
-cmd=$0 ; cmdargs=$@
+export cmd=$0 ; export cmdargs=$@
 SETTE_DIR=$(cd $(dirname "$0"); pwd)
 MAIN_DIR=$(dirname $SETTE_DIR)
Index: /utils/CI/sette_ticket2673/sette_list_avail_cfg.sh
===================================================================
--- /utils/CI/sette_ticket2673/sette_list_avail_cfg.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/sette_list_avail_cfg.sh	(revision 14870)
@@ -16,4 +16,5 @@
 printf "%-15s \n" VORTEX
 printf "%-15s \n" ICE_AGRIF
+printf "%-15s \n" SWG
 printf "%-15s \n" ISOMIP+
 echo ''
Index: /utils/CI/sette_ticket2673/sette_list_avail_rev.sh
===================================================================
--- /utils/CI/sette_ticket2673/sette_list_avail_rev.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/sette_list_avail_rev.sh	(revision 14870)
@@ -8,7 +8,8 @@
 
 if [ $# -gt 0 ]; then
-  while getopts c:h option; do 
+  while getopts c:v:h option; do 
      case $option in
         c) COMPILER=$OPTARG;;
+        v) SETTE_SUB_VAL=$OPTARG;;
         h | *) echo ''
                echo 'sette_list_avail_rev.sh : ' 
@@ -16,4 +17,6 @@
                echo '-c COMPILER_name :'
                echo '     list all sette directory and available revisions created with the compiler specified'
+               echo ' -v sub_dir :'
+               echo '     validation sub-directory below NEMO_VALIDATION_DIR'
                echo ''
                exit 42;;
@@ -22,36 +25,27 @@
   shift $((OPTIND - 1))
 fi
+if [ ! -z $SETTE_SUB_VAL ] ; then
+ NEMO_VALIDATION_DIR=$NEMO_VALIDATION_DIR/$SETTE_SUB_VAL
+fi
 
 #
 lst_rev () {
     # get the list of revision available for a configuration
-    if [ ! -d $1 ] ; then 
-       CFGLST=-9999
-    else
-       CFGLST=`ls $1 | sort -u -r ` 
-    fi
+    # base directory
+    VALSUB=$1
     # config name
     CONFIG=$2
     # list of all revision available
     ALLLST=${@:3}
-    # number of revision total and for CONFIG
-    nrevall=`echo $ALLLST | wc -w`
-    nrevcfg=`echo $CFGLST | wc -w`
     # display
     echo ""
     printf "%-27s : " $CONFIG
-    irev=1
-    irevcfg=1
-    while [[ $irev -le $nrevall ]] ; do
-       rev=`echo $ALLLST | cut -d\  -f ${irev}`
-       cfgrev=`echo $CFGLST | cut -d\  -f ${irevcfg}`
-       if [ -z $cfgrev ] ; then cfgrev=-9999 ; fi
-       if [ $cfgrev == $rev ] ; then
+    for rev in $ALLLST
+    do
+       if [ -d ${VALSUB}/$rev/${CONFIG} ]  ; then
           printf "%-6s  " $rev
-          irevcfg=$((irevcfg+1))
        else
-          printf "%-5s  " "***** " 
+          printf "%-5s  " "----- " 
        fi
-       irev=$((irev+1))
     done
 }
@@ -61,5 +55,6 @@
  
  # list of all revision available
- DIRLST=`find ${NEMO_VALID} -maxdepth 3 -mindepth 3 -type d -regex ".*\/W.*\/${COMPILER}\/.*" | sed -e "s/.*\/W.*\/${COMPILER}\///" | sort -u -r`
+ DIRLIST=`find ${NEMO_VALID}/${COMPILER} -maxdepth 1 -mindepth 1 -type d | sort -u -r`
+ DIRLIST=`basename -a $DIRLIST`
 
  # display header
@@ -68,5 +63,5 @@
  echo ""
  printf " List of all avail. rev. is : "
- for dir in `echo $DIRLST`; do printf "%-6s  " $dir ; done
+ for dir in `echo $DIRLIST`; do printf "%-6s  " $dir ; done
  printf "\n"
 
@@ -74,8 +69,8 @@
  echo ""
  echo "   !---- check revision available for each configuration ----!   "
- for CONFIG in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST 
+ for CONFIG in GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 ORCA2_SAS_ICE AGRIF_DEMO SWG ISOMIP+ OVERFLOW LOCK_EXCHANGE VORTEX ICE_AGRIF 
  do
-    DIR=${NEMO_VALIDATION_DIR}/${CONFIG}/${COMPILER}
-    lst_rev $DIR $CONFIG $DIRLST
+    DIR=${NEMO_VALIDATION_DIR}/${COMPILER}/
+    lst_rev $DIR $CONFIG $DIRLIST
  done
  printf "\n"
Index: /utils/CI/sette_ticket2673/sette_reference-configurations.sh
===================================================================
--- /utils/CI/sette_ticket2673/sette_reference-configurations.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/sette_reference-configurations.sh	(revision 14870)
@@ -121,9 +121,9 @@
 # ORCA2_OFF_PISCES  :
 # AMM12             :
-# SAS               :
+# SAS               : aka ORCA2_SAS_ICE
 # ORCA2_ICE_OBS     :
-# AGRIF             : test AGRIF in a double zoom configuration in the nordic seas + 1 zoom in the eq. Pacific (AGRIF_DEMO)
-#                       and check that key_agrif without zoom = no key_agrif
-# WED025           : regional configuration including sea-ice and tides (Spitzbergen)
+# AGRIF             : AGRIF_DEMO: test AGRIF in a double zoom configuration in the nordic seas + 1 zoom in the eq. Pacific and
+#                     AGRIF_DEMO_NOAGRIF: check that key_agrif without zoom = no key_agrif
+# WED025            : regional configuration including sea-ice and tides (Spitzbergen)
 
 for config in ${TEST_CONFIGS[@]}
Index: /utils/CI/sette_ticket2673/sette_rpt.sh
===================================================================
--- /utils/CI/sette_ticket2673/sette_rpt.sh	(revision 14869)
+++ /utils/CI/sette_ticket2673/sette_rpt.sh	(revision 14870)
@@ -257,5 +257,5 @@
 #
 # check if reference directory is present
-  if [ ! -d $vdirref/$mach/$dorv/$namref ]; then
+  if [ ! -d $vdirref/$mach/$dorv/$nam ]; then
     printf "%-27s %s\n" $nam " REFERENCE directory at $dorvref is MISSING"
     return
@@ -270,6 +270,6 @@
     f1s=$vdir/$mach/$dorv/$nam/LONG/run.stat
     f1t=$vdir/$mach/$dorv/$nam/LONG/tracer.stat
-    f2s=$vdirref/$mach/$dorv/$namref/LONG/run.stat
-    f2t=$vdirref/$mach/$dorv/$namref/LONG/tracer.stat
+    f2s=$vdirref/$mach/$dorv/$nam/LONG/run.stat
+    f2t=$vdirref/$mach/$dorv/$nam/LONG/tracer.stat
     if  [ ! -f $f1s ] && [ ! -f $f1t ] ; then
       printf "%-20s %s\n" $nam " incomplete test";
@@ -343,5 +343,5 @@
 #
 # check if reference directory is present
-  if [ ! -d $vdirref/$mach/$dorv/$namref ]; then
+  if [ ! -d $vdirref/$mach/$dorv/$nam ]; then
     return
   fi
@@ -353,5 +353,5 @@
   if [ -d $vdir/$mach/$dorv/$nam ]; then
     f1a=$vdir/$mach/$dorv/$nam/LONG/timing.output
-    f2a=$vdirref/$mach/$dorv/$namref/LONG/timing.output
+    f2a=$vdirref/$mach/$dorv/$nam/LONG/timing.output
 #
 # Report average CPU time differences (if available)
@@ -572,6 +572,6 @@
  echo ""
  echo "   !----agrif check----!   "
- dir1=WAGRIF_DEMO_NOAGRIF_ST
- dir2=WAGRIF_DEMO_ST
+ dir1=AGRIF_DEMO_NOAGRIF
+ dir2=AGRIF_DEMO
  identictest $NEMO_VALID $dir1 $dir2 $pass 
 #